# Flowpack.JobQueue.Redis

A job queue backend for the [Flowpack.JobQueue.Common](https://github.com/Flowpack/jobqueue-common) package based on [redis](http://redis.io/).

## Usage

Install the package using composer:

```
composer require flowpack/jobqueue-redis
```

If not already installed, that will fetch its requirements, namely `jobqueue-common`.

*NOTE:* This package needs a [redis](http://redis.io/) server and the [PHP redis extension](https://github.com/phpredis/phpredis) to be installed

Now the queue can be configured like this:

```yaml
Flowpack:
  JobQueue:
    Common:
      queues:
        'some-queue':
          className: 'Flowpack\JobQueue\Redis\Queue\RedisQueue'
          executeIsolated: true
          options:
            client:
              host: 127.0.0.1
              port: 6379
              database: 15
              password: 'some long secret'
            defaultTimeout: 20
```

## Specific options


The `RedisQueue` supports following options:

| Option         | Type    | Default                                                                                                        | Description                                                                                                                                                             |
|----------------|---------|----------------------------------------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| defaultTimeout | integer | 60                                                                                                             | Number of seconds new messages are waited for before a timeout occurs (This is overridden by a "timeout" argument in the `waitAndTake()` and `waitAndReserve()` methods |
| client         | array   |  ['host' => '127.0.0.1', 'port' => 6379, 'database' => 0, 'timeout' => <defaultTimeout * 1.5>, password => ''] | Redis connection settings                                                                                                                                               |

### Submit options

The `RedisQueue` currently doesn't support any custom submit options

### Release options

The `RedisQueue` currently doesn't support any custom release options

## License

This package is licensed under the MIT license

## Contributions

Pull-Requests are more than welcome. Make sure to read the [Code Of Conduct](CodeOfConduct.rst).
